<?php
/**
 * Custom functions that act independently of the theme templates.
 *
 * Eventually, some of the functionality here could be replaced by core features.
 *
 * @package prime_cyber_security
 */

/**
 * Adds custom classes to the array of body classes.
 *
 * @param array $classes Classes for the body element.
 * @return array
 */
function prime_cyber_security_body_classes( $classes ) {
  global $prime_cyber_security_post;
  
    if( !is_page_template( 'template-home.php' ) ){
        $classes[] = 'inner';
        // Adds a class of group-blog to blogs with more than 1 published author.
    }

    if ( is_multi_author() ) {
        $classes[] = 'group-blog ';
    }

    // Adds a class of custom-background-image to sites with a custom background image.
    if ( get_background_image() ) {
        $classes[] = 'custom-background-image';
    }
    
    // Adds a class of custom-background-color to sites with a custom background color.
    if ( get_background_color() != 'ffffff' ) {
        $classes[] = 'custom-background-color';
    }
    

    if( prime_cyber_security_woocommerce_activated() && ( is_shop() || is_product_category() || is_product_tag() || 'product' === get_post_type() ) && ! is_active_sidebar( 'shop-sidebar' ) ){
        $classes[] = 'full-width';
    }    

    // Adds a class of hfeed to non-singular pages.
    if ( ! is_page() ) {
        $classes[] = 'hfeed ';
    }
  
    if( is_404() ||  is_search() ){
        $classes[] = 'full-width';
    }
  
    if( ! is_active_sidebar( 'right-sidebar' ) ) {
        $classes[] = 'full-width'; 
    }

    return $classes;
}
add_filter( 'body_class', 'prime_cyber_security_body_classes' );

 /**
 * 
 * @link http://www.altafweb.com/2011/12/remove-specific-tag-from-php-string.html
 */
function prime_cyber_security_strip_single( $tag, $string ){
    $string=preg_replace('/<'.$tag.'[^>]*>/i', '', $string);
    $string=preg_replace('/<\/'.$tag.'>/i', '', $string);
    return $string;
}

if ( ! function_exists( 'prime_cyber_security_excerpt_more' ) ) :
/**
 * Replaces "[...]" (appended to automatically generated excerpts) with ... * 
 */
function prime_cyber_security_excerpt_more($more) {
  return is_admin() ? $more : ' &hellip; ';
}
endif;
add_filter( 'excerpt_more', 'prime_cyber_security_excerpt_more' );

if( ! function_exists( 'prime_cyber_security_footer_credit' ) ):
/**
 * Footer Credits
*/
function prime_cyber_security_footer_credit() {
    // Check if footer copyright is enabled
    $prime_cyber_security_show_footer_copyright = get_theme_mod( 'prime_cyber_security_footer_setting', true );

    if ( ! $prime_cyber_security_show_footer_copyright ) {
        return; 
    }
    $prime_cyber_security_copyright_text = get_theme_mod('prime_cyber_security_footer_copyright_text');

    $prime_cyber_security_text = '<div class="site-info"><div class="container"><span class="copyright">';
    if ($prime_cyber_security_copyright_text) {
        $prime_cyber_security_text .= wp_kses_post($prime_cyber_security_copyright_text); 
    } else {
        $prime_cyber_security_text .= esc_html__('&copy; ', 'prime-cyber-security') . date_i18n(esc_html__('Y', 'prime-cyber-security')); 
        $prime_cyber_security_text .= ' <a href="' . esc_url(home_url('/')) . '">' . esc_html(get_bloginfo('name')) . '</a>' . esc_html__('. All Rights Reserved.', 'prime-cyber-security');
    }
    $prime_cyber_security_text .= '</span>';
    $prime_cyber_security_text .= '<span class="by"> <a href="' . esc_url('https://www.themeignite.com/products/free-cyber-wordpress-theme') . '" rel="nofollow" target="_blank">' . PRIME_CYBER_SECURITY_THEME_NAME . '</a>' . esc_html__(' By ', 'prime-cyber-security') . '<a href="' . esc_url('https://themeignite.com/') . '" rel="nofollow" target="_blank">' . esc_html__('Themeignite', 'prime-cyber-security') . '</a>.';
    /* translators: %s: link to WordPress.org */
    $prime_cyber_security_text .= sprintf(esc_html__(' Powered By %s', 'prime-cyber-security'), '<a href="' . esc_url(__('https://wordpress.org/', 'prime-cyber-security')) . '" target="_blank">WordPress</a>.');
    if (function_exists('the_privacy_policy_link')) {
        $prime_cyber_security_text .= get_the_privacy_policy_link();
    }
    $prime_cyber_security_text .= '</span></div></div>';
    echo apply_filters('prime_cyber_security_footer_text', $prime_cyber_security_text);
}
add_action('prime_cyber_security_footer', 'prime_cyber_security_footer_credit');
endif;

/**
 * Is Woocommerce activated
*/
if ( ! function_exists( 'prime_cyber_security_woocommerce_activated' ) ) {
  function prime_cyber_security_woocommerce_activated() {
    if ( class_exists( 'woocommerce' ) ) { return true; } else { return false; }
  }
}

if( ! function_exists( 'prime_cyber_security_change_comment_form_default_fields' ) ) :
/**
 * Change Comment form default fields i.e. author, email & url.
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function prime_cyber_security_change_comment_form_default_fields( $fields ){    
    // get the current commenter if available
    $prime_cyber_security_commenter = wp_get_current_commenter();
 
    // core functionality
    $req      = get_option( 'require_name_email' );
    $prime_cyber_security_aria_req = ( $req ? " aria-required='true'" : '' );
    $prime_cyber_security_required = ( $req ? " required" : '' );
    $prime_cyber_security_author   = ( $req ? __( 'Name*', 'prime-cyber-security' ) : __( 'Name', 'prime-cyber-security' ) );
    $prime_cyber_security_email    = ( $req ? __( 'Email*', 'prime-cyber-security' ) : __( 'Email', 'prime-cyber-security' ) );
 
    // Change just the author field
    $fields['author'] = '<p class="comment-form-author"><label class="screen-reader-text" for="author">' . esc_html__( 'Name', 'prime-cyber-security' ) . '<span class="required">*</span></label><input id="author" name="author" placeholder="' . esc_attr( $prime_cyber_security_author ) . '" type="text" value="' . esc_attr( $prime_cyber_security_commenter['comment_author'] ) . '" size="30"' . $prime_cyber_security_aria_req . $prime_cyber_security_required . ' /></p>';
    
    $fields['email'] = '<p class="comment-form-email"><label class="screen-reader-text" for="email">' . esc_html__( 'Email', 'prime-cyber-security' ) . '<span class="required">*</span></label><input id="email" name="email" placeholder="' . esc_attr( $prime_cyber_security_email ) . '" type="text" value="' . esc_attr(  $prime_cyber_security_commenter['comment_author_email'] ) . '" size="30"' . $prime_cyber_security_aria_req . $prime_cyber_security_required. ' /></p>';
    
    $fields['url'] = '<p class="comment-form-url"><label class="screen-reader-text" for="url">' . esc_html__( 'Website', 'prime-cyber-security' ) . '</label><input id="url" name="url" placeholder="' . esc_attr__( 'Website', 'prime-cyber-security' ) . '" type="text" value="' . esc_attr( $prime_cyber_security_commenter['comment_author_url'] ) . '" size="30" /></p>'; 
    
    return $fields;    
}
endif;
add_filter( 'comment_form_default_fields', 'prime_cyber_security_change_comment_form_default_fields' );

if( ! function_exists( 'prime_cyber_security_change_comment_form_defaults' ) ) :
/**
 * Change Comment Form defaults
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function prime_cyber_security_change_comment_form_defaults( $defaults ){    
    $defaults['comment_field'] = '<p class="comment-form-comment"><label class="screen-reader-text" for="comment">' . esc_html__( 'Comment', 'prime-cyber-security' ) . '</label><textarea id="comment" name="comment" placeholder="' . esc_attr__( 'Comment', 'prime-cyber-security' ) . '" cols="45" rows="8" aria-required="true" required></textarea></p>';
    
    return $defaults;    
}
endif;
add_filter( 'comment_form_defaults', 'prime_cyber_security_change_comment_form_defaults' );

if( ! function_exists( 'prime_cyber_security_escape_text_tags' ) ) :
/**
 * Remove new line tags from string
 *
 * @param $text
 * @return string
 */
function prime_cyber_security_escape_text_tags( $text ) {
    return (string) str_replace( array( "\r", "\n" ), '', strip_tags( $text ) );
}
endif;

if( ! function_exists( 'wp_body_open' ) ) :
/**
 * Fire the wp_body_open action.
 * Added for backwards compatibility to support pre 5.2.0 WordPress versions.
*/
function wp_body_open() {
    /**
     * Triggered after the opening <body> tag.
    */
    do_action( 'wp_body_open' );
}
endif;

if ( ! function_exists( 'prime_cyber_security_get_fallback_svg' ) ) :    
/**
 * Get Fallback SVG
*/
function prime_cyber_security_get_fallback_svg( $prime_cyber_security_post_thumbnail ) {
    if( ! $prime_cyber_security_post_thumbnail ){
        return;
    }
    
    $prime_cyber_security_image_size = prime_cyber_security_get_image_sizes( $prime_cyber_security_post_thumbnail );
     
    if( $prime_cyber_security_image_size ){ ?>
        <div class="svg-holder">
             <svg class="fallback-svg" viewBox="0 0 <?php echo esc_attr( $prime_cyber_security_image_size['width'] ); ?> <?php echo esc_attr( $prime_cyber_security_image_size['height'] ); ?>" preserveAspectRatio="none">
                    <rect width="<?php echo esc_attr( $prime_cyber_security_image_size['width'] ); ?>" height="<?php echo esc_attr( $prime_cyber_security_image_size['height'] ); ?>" style="fill:#dedddd;"></rect>
            </svg>
        </div>
        <?php
    }
}
endif;

function prime_cyber_security_enqueue_google_fonts() {

    require get_template_directory() . '/inc/wptt-webfont-loader.php';

    wp_enqueue_style(
        'google-fonts-josefin-sans',
        wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Josefin+Sans:ital,wght@0,100..700;1,100..700&display=swap' ),
        array(),
        '1.0'
    );
}
add_action( 'wp_enqueue_scripts', 'prime_cyber_security_enqueue_google_fonts' );


if( ! function_exists( 'prime_cyber_security_site_branding' ) ) :
/**
 * Site Branding
*/
function prime_cyber_security_site_branding(){
    $prime_cyber_security_logo_site_title = get_theme_mod( 'header_site_title', 1 );
    $prime_cyber_security_tagline = get_theme_mod( 'header_tagline', false );
    $prime_cyber_security_logo_width = get_theme_mod('logo_width', 100); // Retrieve the logo width setting

    ?>
    <div class="site-branding" style="max-width: <?php echo esc_attr(get_theme_mod('logo_width', '-1'))?>px;">
        <?php 
        // Check if custom logo is set and display it
        if (function_exists('has_custom_logo') && has_custom_logo()) {
            the_custom_logo();
        }
        if ($prime_cyber_security_logo_site_title):
             if (is_front_page()): ?>
            <h1 class="site-title" style="font-size: <?php echo esc_attr(get_theme_mod('prime_cyber_security_site_title_size', '30')); ?>px;">
            <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
          </h1>
            <?php else: ?>
                <p class="site-title" itemprop="name">
                    <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
                </p>
            <?php endif; ?>
        <?php endif; 
    
        if ($prime_cyber_security_tagline) :
            $prime_cyber_security_description = get_bloginfo('description', 'display');
            if ($prime_cyber_security_description || is_customize_preview()) :
        ?>
                <p class="site-description" itemprop="description"><?php echo $prime_cyber_security_description; ?></p>
            <?php endif;
        endif;
        ?>
    </div>
    <?php
}
endif;
if( ! function_exists( 'prime_cyber_security_navigation' ) ) :
    /**
     * Site Navigation
    */
    function prime_cyber_security_navigation(){
        ?>
        <nav class="main-navigation" id="site-navigation" role="navigation">
            <?php 
            wp_nav_menu( array( 
                'theme_location' => 'primary', 
                'menu_id' => 'primary-menu' 
            ) ); 
            ?>
        </nav>
        <?php
    }
endif;

if( ! function_exists( 'prime_cyber_security_header' ) ) :
    /**
     * Header Start
    */
    function prime_cyber_security_header(){
        $prime_cyber_security_header_image = get_header_image();
        $prime_cyber_security_sticky_header = get_theme_mod('prime_cyber_security_sticky_header');?>
        <div id="page-site-header" class="main-header">
            <header id="masthead" class="site-header header-inner" role="banner">
                        <div class="theme-menu head_bg" <?php echo $prime_cyber_security_header_image != '' ? 'style="background-image: url(' . esc_url( $prime_cyber_security_header_image ) . '); background-repeat: no-repeat; background-size: 100% 100%"': ""; ?> data-sticky="<?php echo esc_attr( $prime_cyber_security_sticky_header ); ?>">
                            <div class="container">
                                <div class="row header_bg">
                                    <div class="col-xl-3 col-lg-3 col-md-4 align-self-center">
                                        <?php prime_cyber_security_site_branding(); ?>
                                    </div>
                                    <div class="col-xl-7 col-lg-6 col-md-2 align-self-center">
                                       <?php prime_cyber_security_navigation(); ?> 
                                    </div>
                                    <div class="col-xl-2 col-lg-3 col-md-6 col-sm-4 align-self-center text-md-end text-center my-2">
                                        <?php if ( get_theme_mod('prime_cyber_security_header_login_link') ) : ?>
                                            <a class="login" href="<?php echo esc_url(get_theme_mod('prime_cyber_security_header_login_link','')); ?>"><?php esc_html_e('Log In','prime-cyber-security'); ?></a>
                                        <?php endif; ?>
                                        <?php if ( get_theme_mod('prime_cyber_security_header_signin_link') ) : ?>
                                            <a class="sign-in-area ms-2" href="<?php echo esc_url(get_theme_mod('prime_cyber_security_header_signin_link','')); ?>"><?php esc_html_e('Sign In','prime-cyber-security'); ?></a>
                                        <?php endif; ?>
                                    </div>
                                </div>
                            </div>
                        </div>
                    
            </header>
        </div>
        <?php
    }
endif;
add_action( 'prime_cyber_security_header', 'prime_cyber_security_header', 20 );
